/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

entry = window.arguments[0];
listsrc = entry.Inputs;
var cqrAction = window.opener.top.cqrAction;
var firstinp = true;
var ListBuilt = false;
var FocusedTbox = new Object();
window.opener.top.cancel = true;

function listloader(){
	window.setTimeout('MakeLists();', 0);
}

function MakeLists(){
try{
  document.title = entry.Title;
  rs = document.createElement('rows');
  
  //Action textbox
	row = document.createElement('row');
	lbl = document.createElement('label');
	lbl.setAttribute("value", "Action:");
  row.appendChild(lbl);
  tbox = document.createElement('textbox');
  tbox.setAttribute("id", "action");
  row.appendChild(tbox);
  rs.appendChild(row);
  setval("action", entry.Action, tbox);

  for (i in listsrc){
    if (listsrc[i].list){
			//vbox = document.createElement('vbox');
			row = document.createElement('row');
			//row.setAttribute("flex", "1");
    	lbl = document.createElement('label');
    	if (listsrc[i].grouptitle) {lbl.setAttribute("value", listsrc[i].grouptitle+":")}else{lbl.setAttribute("value", listsrc[i].name+":")};
      row.appendChild(lbl);
      rs.appendChild(row);
      
      row = document.createElement('row');
      row.setAttribute("id", "hbox_"+i);
    	lst = document.createElement('menulist');
      lst.setAttribute("id", "list_"+i);
      lst.setAttribute("oncommand", "list_onsel('"+i+"', this)");
      pp = document.createElement('menupopup');
      item = document.createElement('menuitem');
      if (listsrc[i].def.label) {item.setAttribute("label", listsrc[i].def.label)}else{item.setAttribute("label", listsrc[i].def.value)};
      item.setAttribute("value", listsrc[i].def.value);
      pp.appendChild(item);

    	for (v in listsrc[i].list){
        if (listsrc[i].def.priority != v) {
          item = document.createElement('menuitem');
          if (listsrc[i].list[v].label){item.setAttribute("label", listsrc[i].list[v].label)}else{item.setAttribute("label", listsrc[i].list[v].value)};
          item.setAttribute("value", listsrc[i].list[v].value);
          pp.appendChild(item);
        }
    	}
      tbox = document.createElement('textbox');
      tbox.setAttribute("id", i);
      lst.appendChild(pp);
      row.appendChild(lst);
      row.appendChild(tbox);
      rs.appendChild(row);
      setval(i, listsrc[i].value, tbox);
    } else {
      if (listsrc[i].value.search(/\[:(\w+)(:(\d*))?\]/gi)!=-1){
			row = document.createElement('row');
    	lbl = document.createElement('label');
    	if (listsrc[i].label) {lbl.setAttribute("value", listsrc[i].label+":")}else{lbl.setAttribute("value", listsrc[i].name+":")};
      row.appendChild(lbl);
      tbox = document.createElement('textbox');
      tbox.setAttribute("id", i);
      row.appendChild(tbox);
      rs.appendChild(row);
      setval(i, listsrc[i].value, tbox);
      }
    }
  }
	grid = document.getElementById("cqr-grd");
	grid.appendChild(rs);
	window.sizeToContent();
  var x   = window.opener.screenX + window.opener.outerWidth/2;
  var y   = window.opener.screenY + window.opener.outerHeight/2;
  window.screenX = Math.max(0, x - window.outerWidth/2);
  window.screenY = Math.max(0, y - window.outerHeight/2);
  ListBuilt = true;
  FocusedTbox.focus();
}catch(er){cqerr(er, "MakeLists sub")}
}

function setval(id, val, tbox){
  //tbox = document.getElementById(id);
  var tmpval = window.opener.top.SubstVars(val, entry);
  if (tmpval == val){
    if (ListBuilt) {
      tbox.value = val;
      tbox.readonly = true;
    } else {
      tbox.setAttribute("value", val);
      tbox.setAttribute("readonly", true);
    }
  } else {
    if (ListBuilt) {
      tbox.value = tmpval;
      tbox.readonly = false;
    } else {
      tbox.setAttribute("value", tmpval);
      //tbox.setAttribute("readonly", false);
      tbox.readonly = false;
      if (firstinp) {FocusedTbox = tbox; firstinp=false}
    }
  }
}

function list_onsel(id, list){
  tbox = document.getElementById(id);
  setval(id, list.value, tbox);
}

function onOk(){
try{
	window.opener.top.cancel = false;
  for (i in listsrc){
    if (listsrc[i].list){
			lst = document.getElementById("list_"+i);
			QueryHash[listsrc[i].def.name] = lst.selectedItem.value;
    }else{
    	QueryHash[listsrc[i].def.name] = listsrc[i].def.value;
    }
  }

	tbs = document.getElementsByTagName("textbox");
	for (i=0; i<tbs.length;i++) {
	  if (tbs[i].id == "action"){
	    window.opener.top.cqrAction = tbs[i].value;
	  } else {
	    QueryHash[tbs[i].id] = tbs[i].value;
	  }
	}
	window.opener.top.QueryHash = QueryHash;
}catch(err){cqerr(err, "")}
}
